classification
Title: incorrect __all__ list in multiprocessing.managers module
Type: behavior Stage: resolved
Components: Library (Lib) Versions: Python 3.9, Python 3.8, Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: ZackerySpytz, davin, lukasz.langa, miss-islington, pitrou
Priority: normal Keywords: patch

Created on 2019-11-18 22:18 by xdegaye, last changed 2021-08-09 17:39 by lukasz.langa. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 17296 closed xdegaye, 2019-11-20 15:54
PR 18034 merged ZackerySpytz, 2020-01-17 06:43
PR 27684 merged miss-islington, 2021-08-09 16:45
PR 27685 merged miss-islington, 2021-08-09 16:45
Messages (5)
msg356922 - (view) Author: Xavier de Gaye (xdegaye) * (Python triager) Date: 2019-11-18 22:18
On android which is a platform that is missing the shared memory implementation, test___all__ fails because 'multiprocessing.managers' has no attribute 'SharedMemoryManager' which is listed in __all__.


2|generic_x86_64:/data/local/tmp/python $ python
Python 3.9.0a0 (heads/abifa-dirty:cf805c25e6, Nov 18 2019, 16:40:26) 
[Clang 8.0.2 (https://android.googlesource.com/toolchain/clang 40173bab62ec7462 on linux
Type "help", "copyright", "credits" or "license" for more information.
>>> import multiprocessing.shared_memory
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "/data/local/tmp/python/lib/python3.9/multiprocessing/shared_memory.py", line 22, in <module>
    import _posixshmem
ModuleNotFoundError: No module named '_posixshmem'
>>> 


2|generic_x86_64:/data/local/tmp/python $ python -m test test___all__
0:00:00 Run tests sequentially
0:00:00 [1/1] test___all__
test test___all__ failed -- Traceback (most recent call last):
  File "/data/local/tmp/python/lib/python3.9/test/test___all__.py", line 38, in check_all
    exec("from %s import *" % modname, names)
AttributeError: module 'multiprocessing.managers' has no attribute 'SharedMemoryManager'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/data/local/tmp/python/lib/python3.9/test/test___all__.py", line 41, in check_all
    self.fail("__all__ failure in {}: {}: {}".format(
AssertionError: __all__ failure in multiprocessing.managers: AttributeError: module 'multiprocessing.managers' has no attribute 'SharedMemoryManager'

test___all__ failed

== Tests result: FAILURE ==

1 test failed:
    test___all__

Total duration: 1.8 sec
Tests result: FAILURE
msg358165 - (view) Author: Xavier de Gaye (xdegaye) * (Python triager) Date: 2019-12-10 07:45
Not interested anymore in android stuff.
msg399277 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2021-08-09 16:45
New changeset d0978761118856e8ca8ea7b162a6585b8da83df9 by Zackery Spytz in branch 'main':
bpo-38840: Incorrect __all__ in multiprocessing.managers (GH-18034)
https://github.com/python/cpython/commit/d0978761118856e8ca8ea7b162a6585b8da83df9
msg399282 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2021-08-09 17:31
New changeset 40b353bc079b990cf0d6259a5720fb9729c1b81e by Miss Islington (bot) in branch '3.9':
bpo-38840: Incorrect __all__ in multiprocessing.managers (GH-18034) (GH-27684)
https://github.com/python/cpython/commit/40b353bc079b990cf0d6259a5720fb9729c1b81e
msg399283 - (view) Author: miss-islington (miss-islington) Date: 2021-08-09 17:39
New changeset 8ece98a7e418c3c68a4c61bc47a2d0931b59a889 by Miss Islington (bot) in branch '3.10':
bpo-38840: Incorrect __all__ in multiprocessing.managers (GH-18034)
https://github.com/python/cpython/commit/8ece98a7e418c3c68a4c61bc47a2d0931b59a889
History
Date User Action Args
2021-08-09 17:39:45lukasz.langasetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2021-08-09 17:39:13miss-islingtonsetmessages: + msg399283
2021-08-09 17:31:18lukasz.langasetmessages: + msg399282
2021-08-09 16:45:38miss-islingtonsetpull_requests: + pull_request26171
2021-08-09 16:45:33miss-islingtonsetnosy: + miss-islington
pull_requests: + pull_request26170
2021-08-09 16:45:02lukasz.langasetnosy: + lukasz.langa
messages: + msg399277
2020-01-17 06:45:25ZackerySpytzsetnosy: + ZackerySpytz

versions: + Python 3.7, Python 3.8
2020-01-17 06:43:55ZackerySpytzsetpull_requests: + pull_request17430
2019-12-10 07:52:54xdegayesetnosy: - xdegaye
2019-12-10 07:45:42xdegayesetnosy: pitrou, xdegaye, davin
messages: + msg358165
2019-11-22 21:38:13terry.reedysetnosy: + pitrou, davin
2019-11-20 15:54:34xdegayesetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request16788
2019-11-18 22:18:22xdegayecreate